var sqlite3 = require('sqlite3');
var open = require('sqlite').open;
var path = require('path');
var db_utility = require('../utility/db_utility')
 
// this is a top-level await 


var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await db_utility.getDbConnection();

        let result = await db.run('INSERT INTO user (username, password, email) VALUES (@username, @password, @email)', 
        { '@username': entity.username, '@password': entity.password, '@email': entity.email});
        
        await db.close()
        return result;
    },
    update: async (entity) => {
        const db = await db_utility.getDbConnection();

        let result = await db.run('UPDATE user SET level = @level, updated_at = CURRENT_TIMESTAMP WHERE username = @username',
            { '@level': entity.level, '@username': entity.username });

        await db.close();
        return result;
    },
    delete: (id) => {
        // Deletes entity of given id from db table
    },
    exists: (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
    },
    count: () => {
        // Returns total number of entities in db table
    },
    findById: (id) => {
        // Returns entity with given id from db table, null if not existent
    },
    findByUsername: async (username) => {
        // Returns entity with given username from db table, null if not existent
        const db = await db_utility.getDbConnection();
        
        const stmt = await db.prepare('SELECT * FROM user WHERE username = @username')
        
        await stmt.bind({ '@username': username });

        let result = await stmt.get();
        await stmt.finalize();
        
        await db.close()
        return result;
    },
    getAll: async () => {
        const db = await db_utility.getDbConnection();
        
        const stmt = await db.prepare('SELECT * FROM user')

        let result = await stmt.get();
        await stmt.finalize();
        
        await db.close()
        return result;
    },
    getRoleByName: async (name) => {
        const db = await db_utility.getDbConnection();
        
        const stmt = await db.prepare('SELECT * FROM role WHERE role_name = @name')
        
        await stmt.bind({ '@name': name });

        let result = await stmt.get();

        await stmt.finalize();
        
        await db.close()
        return result;
    },
    addRoleToUser: async (user_id, role_id) => {
        const db = await db_utility.getDbConnection();

        let result = await db.run('INSERT INTO user_role (u_id, r_id) VALUES (@user_id, @role_id);', 
        { '@user_id': user_id, '@role_id': role_id });

        await db.close();
        return result;
    },
    getRolesForUser: async (id) => {
        const db = await db_utility.getDbConnection();
        
        const stmt = await db.prepare('SELECT role_name FROM role WHERE id=(SELECT r_id FROM user_role WHERE u_id = @uid)')
        
        await stmt.bind({ '@uid': id });

        let result = await stmt.get();

        await stmt.finalize();
        
        await db.close()
        return result;
    },
    getUsersOfRole: async (role) => {
        const db = await db_utility.getDbConnection();
        
        const stmt = await db.prepare('SELECT user.id, user.username, user.email, user.level, user.points FROM user INNER JOIN user_role ON user.id = user_role.u_id INNER JOIN role on user_role.r_id = role.id WHERE role.role_name = @role;', { '@role': role});
        let result = await stmt.all();
        await stmt.finalize();
        
        await db.close()
        return result;
    }
    
}

module.exports = repository;